import {IonicView, Battery} from 'ionic/ionic';


@IonicView({
  template: `
  <ion-navbar *navbar>
    <button menuToggle>
      <ion-icon name="menu"></ion-icon>
    </button>
    <ion-title>Battery</ion-title>
  </ion-navbar>
  <ion-content padding>
    <h2>Battery</h2>
    <button primary outline (click)="doBatteryStatus()">Get Status</button>
    <div *ngIf="battery">
      Battery charging: <b>{{battery.charging}}</b><br>
      Battery level: <b>{{battery.level * 100}}</b>%<br>
      Battery charging time: <b>{{battery.chargingTime}}</b>s<br>
      Battery discharging time: <b>{{battery.dischargingTime}}</b>s<br>
    </div>

  </ion-content>
  `
})
export class BatteryPage {
  doBatteryStatus() {
    Battery.getStatus().then((battery) => {
      this.battery = battery;
    });
  }
}
